#source("./Estimate-tweedie.R")
#
#########################################################################################
#######   GTE shell for specific "classical" precedure (GTE model driver)       #########
#######   some coef and summary functions!                                      #########
#######                                                                         #########
#######   Returns glm class estimate or NULL                                    #########
#######   Inputs:                                                               #########
#######   data  - model data, expected to be model.frame;                       #########
#######   ind   - data subset;                                                  #########
#######                                                                         #########
#######   ...   - other parameters for current estimate (GLM) procedure.        #########
#######                                                                         #########
#########################################################################################

Estimate=function(data,ind=NULL, model, dmodel, family, method, ... )
{
        if (!is.null(ind)) data = data[ind,]                                    # substr attribute is not appropriate
        else data = data[,]
#
        model=as.formula(model)
        dmodel=as.formula(dmodel)
        estim=NULL
#
        estim = try( dglm (formula=Y ~ A + B,dformula ~ D, family=tweedie(var.power=1, link.power=0), data=data, method = method) ,silent=T)
#
        if(inherits(estim,"try-error")) return(NULL)
#
        return(invisible(estim))                                                # returns result of the estimation procedure
}
#
coef=function(fit) c(mean=coefficients(fit),disp=coefficients(fit$dispersion.fit))
summary=function(fit) fit
