#source("./Density-gauss.R")
#
#########################################################################################
#######   GTE shell for specific "classical" precedure (GTE model driver)       #########
#######   Computes model densities or specific target function values           #########
#######   for given parameter estimates                                         #########
#######                                                                         #########
#######   data  - model data, expected to be model.frame with family attribute; #########
#######   pars  - model estimate.                                               #########
#######           Current parameters extracted via coef function;               #########
#######                                                                         #########
#######   value - Individual(per case) Likelihoods or Target value              #########
#######                 not loglikelihoods!                                     #########
#########################################################################################

Density =function(data, fit, ...)
{
        if(fit$family[1]=="gaussian") {
                mean  = predict(fit, newdata=data, type="response")
                sigma = predict(fit$dispersion.fit, newdata=data, type="response")
                sigma = sqrt(sigma)
                tmp   = dnorm(data$Y,mean,sigma)
        } else stop("Incorrect model family")

return(list(lik=tmp))                                                           #return individual likelihoods - not log likelihoods!!
}

Tprint=function(data,fit,print=T)                                               #additional print of some information about model and data
{
        mean  = predict(fit, newdata=data, type="response")
        sigma = predict(fit$dispersion.fit, newdata=data, type="response")
        sigma = sqrt(sigma)
        tmp   = dnorm(data$Y,mean,sigma,log=T)
#                                       =====
        print(cbind(data,mean=mean,sigma=sigma,q=tmp))

return(invisible(tmp))
}
