#source("./Estimate-gauss.R")
#
#########################################################################################
#######	  GTE shell for	specific "classical" precedure (GTE model driver)	#########
#######	  some coef and	summary	functions!					#########
#######										#########
#######	  Returns glm class estimate or	NULL					#########
#######	  Inputs:								#########
#######	  data	- model	data, expected to be model.frame;			#########
#######	  ind	- data subset;							#########
#######										#########
#######	  ...	- other	parameters for current estimate	(GLM) procedure.	#########
#######										#########
#########################################################################################

Estimate=function(data,ind=NULL, model,	dmodel,	... )
{
	if (!is.null(ind)) data	= data[ind,]					# substr attribute is not appropriate
	else data = data[,]
#
	model=as.formula(model)
	dmodel=as.formula(dmodel)
##	estim=NULL! inappropriate with the next "capture" command. Cause computational exeption
	capture.output(
		estim <<- try(fitjoint("glm", model, dmodel, data = data), silent = T)
	,file =	if(.Platform$OS.type=="unix") NULL else	"nul")
#
	if(inherits(estim,"try-error"))	return(NULL)
#
	return(invisible(estim))						# returns result of the	estimation procedure
}
#
coef=function(fit) c(mean=coefficients(fit$mod.mean),disp=coefficients(fit$mod.disp))
summary=function(fit) fit
