GTE=function(kStar,kTrim,data, nit=100, msglvl=0, result=NULL, cit=9, test=NULL, Density, Estimate, ...)
{
#
	nobs = dim(data)[1]					
#	check restart object					
	if( 	is.null(result) ||				
		is.null(result$kTrim)|| result$kTrim!=kTrim ||	
		is.null(result$nobs) || result$nobs!=nobs   ||
		is.null(result$maxloglik) ||
		is.null(result$estimate)  )
	{	if(msglvl>0) print("New estimate start")			
		estimate	= NULL				
		iterbest	= 0				
		it		= 0				
		sit		= 0				
		maxloglik	= NULL				
		tleweights	= 0				
		tlemem		= 0				
		mcomp		= 1				
	} else 													
	{	if(msglvl>0) print("Restart estimate!")		
		estimate	= result$estimate		
		iterbest	= result$iterbest		
		it		= result$it			
		sit		= result$sit			
		maxloglik	= result$maxloglik		
		indbest		= result$indbest		
		indout		= result$indout			
		tleweights	= result$tleweights		
		tlemem		= result$tlemem			
		tlelogliks	= result$tlelogliks		
		tleclusters	= result$tleclusters		
		mcomp		= result$mcomp			
	}
	Qnew	= NULL
#########################################################################################
#	main GTE loop
#########################################################################################
oldit=it
for(it in (1:nit+oldit))					
{
#	set the	initial	random subsample of rank k*:
	ind <-sort(sample(nobs,kStar))
#
#	control	prints:
		if(msglvl==1) {	if((it-1)%%80==0) cat(it,"\n.") else cat(".") }
		if(msglvl>1) cat("\n iteration:",it,"\n")
#
#	initial	step. Use k* sample
	est	= Estimate(data,ind, ...)
	if(is.null(est)) next()
#
	wrk	= Density(data,est, ...)			
	if(is.null(wrk)) next()
	loglik	= log(wrk$lik)					
	cluster	= wrk$c						
	ccomp	= wrk$cc					
	ncomp	= dim(wrk$cc)[2]				
#
#
	klog	= sort(loglik,index.return=T,decreasing=TRUE)$ix# izbira naj-dobrite
	kSort	= klog[1:kTrim]					
#
 	qtmp	= loglik[kSort]					
 	if(any(is.na(qtmp))) next()				
 	Qold	= sum(qtmp)					
#
	if(msglvl>1) cat("\n Initial sample of size  ",kStar,
			 "\n Estimated LogLik=	     ",Qold,
			 "\n sample observations:    ",ind,
			 "\n")
#
# C-steps:	#########################################################################
	for(cstep in 1:cit)
	{
	if(msglvl>1)progress.bar((it-oldit-1)*9+cstep-1,nit*9+1,title="GTE progress")
	#	Improvement:
		# Get kTrim best cases.
		# Replace all NA values with machine minimal value,
		# in order to obtain correct kTrim indeces:
						
	##	if(any(is.na(loglik))) loglik[is.na(loglik)]=.Machine$double.xmin
		
		# Use appropriate estimation function interface
		est	= Estimate(data,kSort,cluster=ccomp, ...)
		if(is.null(est)) break()
	#
		wrk	= Density(data,est, ...)		
		if(is.null(wrk)) break()
		loglik	= log(wrk$lik)				                                
		cluster	= wrk$c					                                
		ccomp	= wrk$cc				                        
		ncomp	= dim(wrk$cc)[2]			                        
	#	
	#	kSort	= sort(loglik,index.return=T,decreasing=TRUE)$ix[1:kTrim]		
		klog	= sort(loglik,index.return=T,decreasing=TRUE)$ix
		kSort	= klog[1:kTrim]		
	#
	 	qtmp	= loglik[kSort]
 	 	if(any(is.na(qtmp))) break()			                                                    
	 	Qnew	= sum(qtmp)				                                                    
	#                                                                                                                           
		if(is.na(Qnew)) break()				                                                    
	#                                                                                                                           
		totlik	= sum(loglik,na.rm=TRUE)		                                                    
		weights	= rep(0,nobs)                                                                                       
		weights[kSort] = 1				                                                    
	#
		if(msglvl>1) cat("\n C-step",cstep," of	size ",length(kSort),
				 "\n Estimates LogLik=	     ",Qnew,
				 "\n sample observations:    ",sort(kSort),
				 "\n")
	#
		if( is.null(maxloglik) || Qnew > maxloglik )	                                                   
		{	maxloglik	= Qnew		                                                   
			iterbest	= it		                                                   
			totloglik	= totlik		                                                   
			tleweights	= weights		                                                   
			tlelogliks	= loglik		                                                   
			tleclusters	= cluster		                                                                
			indbest		= sort(kSort)	                                                     
			indout		= (1:nobs)[-kSort]	                                                     
			indout		= sort(indout)	                                                     
			estimate	= est			                                                     
	 	 	mcomp		= ncomp		                                                     
	#                                                                                                                           
			if(msglvl>0)  cat("\n =========================================",
					  "\n target updated!",maxloglik,iterbest,mcomp, 
					      if(is.null(test)) "" else paste("(",format(maxloglik-test,digits=3),")",sep=""),
					  "\n =========================================",
					  "\n")
		}
	#
		if(length(ind)==kTrim && all(ind==sort(kSort))){ if(msglvl>1)print("GTE C-step converged"); break () }
		ind<-sort(kSort)
		Qold = Qnew
	} 
	tlemem=tlemem+tleweights
	sit=sit+1						
	stop=!is.null(test)&&!is.null(Qnew)&&test<=Qnew
	if(stop) {print("target OK"); break()}
} 
#
#	Final print:
	if(msglvl>1)
	{	if(!is.null(estimate))
		{	li=length(indbest)
			if(!is.null(maxloglik))
			{   cat("\n best subsample found:",
				"\n ==========================================================================",
				"\n target	      = ",maxloglik,
				"\n num of components = ",mcomp,
				"\n iter of best      =	",iterbest,
				"\n total num.iter.   =	",it,
				"\n total succ.iter.  =	",sit,
				"\n sorted subsample  =	",indbest[1:(li%/%4)],
				"\n		      =	",indbest[(  li%/%4+1):(2*li%/%4)],
				"\n		      =	",indbest[(2*li%/%4+1):(3*li%/%4)],
				"\n		      =	",indbest[(3*li%/%4+1):li],
				"\n outliers	      =	",indout,
				"\n ==========================================================================",
				"\n")
			}
		} else
		{	cat(	"\n No improvement \n")
		}
	}
	cat("\n")
	if(msglvl>1)progress.bar(1,0)
	if(!is.null(estimate))					
	{	result=list(estimate=estimate,
		iterbest=iterbest,it=it,sit=sit,maxloglik=maxloglik,indbest=indbest,indout=indout,
		tleweights=tleweights, tlelogliks=tlelogliks, tleclusters=tleclusters,
		kTrim=kTrim,kStar=kStar,mcomp=mcomp,nobs=nobs,
		tlemem=tlemem,
		data=data)
		attr(result,"stop")=stop
		class(result)="tle"
		return(result)
	}
	else return(NULL)
}
