#
#	Simple identification plot for tle data..................................
#
plot.gte=function(est.gte) {
	if(length(grep("tle",class(est.gte)))>0) {
		#legend:
		#transformation  coded color symbol
		#regular->regular    1 black     21  
		#outlier->regular    2 green     19  
		#regular->outlier    3 blue      19  
		#outlier->outlier    4 red       19  

		jc=which(tolower(colnames(data))=="c")
		if(length(jc)==0 | length(jc)>1) jc=NULL
		col=c("black","green","blue","red")		
		pch=c(21,19,19,19)				
		if(is.null(jc)) {						#no special variable "c" indicating real outliers
			ic=(1-est.gte$tleweights)*3+1
			plot(data,col=col[ic], pch=pch[ic])
		
		}else{	                       					#we know real outliers
			ic=(1-est.gte$tleweights)*2+data[,jc]		
			plot(data[,2:jc-1],col=col[ic], pch=pch[ic])		#plot original variables only
#			plot(data[,-jc],col=col[ic], pch=pch[ic])		#plot and additional variables
		}
		title("Identified outliers",line=3,col.main="red")
	}
}